/// @cond EO_CXX_EO_IMPL

inline ::elm_view_form::_c_model_set elm_view_form::model_set(::efl::model::base model_)
{
   return _c_model_set(model_);
}

inline void elm_view_form::widget_add(::efl::eina::string_view propname_, Evas_Object * evas_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_view_form_widget_add(::efl::eolian::to_c(propname_), evas_));
}

inline void eo_cxx::elm_view_form::widget_add(::efl::eina::string_view propname_, Evas_Object * evas_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_view_form_widget_add(::efl::eolian::to_c(propname_), evas_));
}

inline ::eo_cxx::elm_view_form::operator ::elm_view_form() const
{
   return *static_cast<::elm_view_form const*>(static_cast<void const*>(this));
}

inline ::eo_cxx::elm_view_form::operator ::elm_view_form&()
{
   return *static_cast<::elm_view_form*>(static_cast<void*>(this));
}

inline ::eo_cxx::elm_view_form::operator ::elm_view_form const&() const
{
   return *static_cast<::elm_view_form const*>(static_cast<void const*>(this));
}

template <typename T>
void _elm_view_form_widget_add_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, const char * propname_, Evas_Object * evas_)
{
   try
      {
         static_cast<T*>(self->this_)->widget_add(::efl::eolian::to_cxx<::efl::eina::string_view>(propname_, std::tuple<std::false_type>()), evas_);
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

namespace efl { namespace eo { namespace detail {

template<>
struct operations< ::elm_view_form >
{
   template <typename T>
   struct type
         : virtual operations< ::eo::base >::template type<T>
   {
      virtual void widget_add(::efl::eina::string_view propname_, Evas_Object * evas_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::elm_view_form_widget_add(::efl::eolian::to_c(propname_), evas_));
      }

   };
};


template<>
struct operation_description_class_size< ::elm_view_form >
{
   static constexpr int value = 
#if defined(ELM_VIEW_FORM_PROTECTED) && defined(ELM_VIEW_FORM_BETA)
      1
#elif defined(ELM_VIEW_FORM_PROTECTED)
      1
#elif defined(ELM_VIEW_FORM_BETA)
      1
#else
      1
#endif
      + operation_description_class_size<::eo::base >::value;
};

template <typename T>
int initialize_operation_description(::efl::eo::detail::tag<::elm_view_form>
                                 , Eo_Op_Description* ops)
{
   int i = 0;
   (void)i;
   (void)ops;
   ops[i].func = reinterpret_cast<void*>(& ::_elm_view_form_widget_add_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_view_form_widget_add);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   initialize_operation_description<T>(::efl::eo::detail::tag<::eo::base>(), &ops[operation_description_class_size< ::elm_view_form >::value]);
   return 0;
}
inline Eo_Class const* get_eo_class(tag<::elm_view_form>)
{
   return (ELM_VIEW_FORM_CLASS);
}

} } }

/// @endcond

